# This file is part of "TW-Light" 
#                     http://tw-light.berlios.de/
# Copyright (C) 2001-2004  TimeWarp development team

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

import unittest

class Callable:
    def __init__(self, anycallable):
        self.__call__ = anycallable

jornal = ""

#############################################################################
# Dialogs                                                                   #
#############################################################################
class DialogApi:
    def startDialog():
        global jornal
        jornal += "startDialog "
    def endDialog():
        global jornal
        jornal += "endDialog "
    def askPlayer(answer):
        global jornal
        jornal += "askPlayer "
        return 0
    def showText(text,delay,x,y):
        global jornal
        jornal += "showText "
    def showAlienPicture(background):
        global jornal
        jornal += "showAlienPicture "
    startDialog      = Callable(startDialog)
    endDialog        = Callable(endDialog)
    askPlayer        = Callable(askPlayer)
    showText         = Callable(showText)
    showAlienPicture = Callable(showAlienPicture)
    # Test Interface
    def clearJornal():
        global jornal
        jornal = ""
    def getJornal():
        global jornal
        return jornal
    clearJornal = Callable(clearJornal)
    getJornal   = Callable(getJornal)

############################################################################
# Sound                                                                    #
############################################################################
def GetSoundSystem():
    return SoundSystem()

class SoundSystem:
    def play_music(self,file, loops = -1):
        global jornal
        jornal += "play_music "
    def play_sound(self,file, vol = -1):
        global jornal
        jornal += "play_music "
    def stop_sound(self,file):
        global jornal
        jornal += "stop_sound "
    def set_music_volume(self,vol):
        global jornal
        jornal += "play_music "
    def playing_music(self):
        global jornal
        jornal += "playing_music "
        return False
    def playing_music_file(self):
        global jornal
        jornal += "playing_music_file "
        return ""
#############################################################################
#            TESTS                                                          #
#############################################################################
class TestDialogApiFunctions(unittest.TestCase):
    def setUp(self):
        DialogApi.clearJornal()
    def testClearJornal(self):
        DialogApi.startDialog()
        DialogApi.clearJornal()
        self.assertEqual('',DialogApi.getJornal())
    def testAddJornalEntry(self):
        DialogApi.startDialog()
        self.assertEqual('startDialog ',DialogApi.getJornal())

        
if __name__ == '__main__':
    unittest.main()
