/*
This file is part of "TW-Light" 
                    http://tw-light.berlios.de/
Copyright (C) 2001-2004  TimeWarp development team

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

#include "melee/mship.h" // for Ship class
#include "melee/WarpOutTrail.h"
#include "gobwarpouttrail.h"
#include "games/ggob.h"

#include <string>

GobWarpEffect::GobWarpEffect(const std::string & targetSystem, GobGame * gobGame) :
  targetSystem(targetSystem),
  gobGame(gobGame)
{
  STACKTRACE;
}

void GobWarpEffect::startEffect() {
  STACKTRACE;
  //yB! should uncomment this when we know there is only one call to this per
  //instance of GobWarpEffect.  Currently, this keeps getting called
  //gobGame->item.remove(gobGame->gobplayer.ship);
  printf("GobWarpEffect::startEffect()\n");
}
  
void GobWarpEffect::endEffect() {
  STACKTRACE;
  gobGame->switch_system(targetSystem);
  printf("GobWarpEffect::endEffect()\n");
}


GobWarpOutTrail::GobWarpOutTrail(
         const std::string & targetSystem,
         GobGame * gobGame,
         SpaceLocation *creator, Vector2 pos, Vector2 rel_pos, 
         SpaceSprite *sprite, int osprite_index, int *ocolors, 
         int onum_colors, int ofsize, int steps, int step_time) :
     Phaser(creator, pos, rel_pos, 
	    sprite, osprite_index, ocolors, 
	    onum_colors, ofsize, steps, step_time, PhaserEffectPtr(new GobWarpEffect(targetSystem, gobGame)))
{
  STACKTRACE;
}

GobWarpOutTrail * GobWarpOutTrail::getGobWarpOutTrail(Ship * ship, 
    const std::string & targetSystem,
    GobGame * gobGame)
{
  STACKTRACE;
  if (!ship) {
    tw_error("In getGobWarpOutTrail(), parameter ship was null");
    return NULL;
  }
  return new GobWarpOutTrail(
            targetSystem,
            gobGame, 
	    ship,
            ship->pos + unit_vector(ship->get_angle()) * 0 * ship->get_size().x,
            unit_vector(ship->get_angle()) * PHASE_MAX * ship->get_size().x, 
            ship->get_sprite(), 
            ship->get_sprite_index(), 
            inverse_hot_color, 
            INVERSE_HOT_COLORS,
            PHASE_DELAY, 
            PHASE_MAX, 
            PHASE_DELAY
            );
}
