/*
This file is part of "TW-Light" 
                    http://tw-light.berlios.de/
Copyright (C) 2001-2004  TimeWarp development team

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

#include <cppunit/ui/text/TestRunner.h>
#include <cppunit/extensions/HelperMacros.h>

#include "gameconfigtest.h"
#include "tml/gameconfig.h"
#include "util/errors.h"

#include <string>

void TestGameConfig::testSetGameDirectory()
{
  STACKTRACE;
  std::string game_dir = "/home/yura/gm";
  GameConfig::SetGameDirectory("/home/yura/gm");
  CPPUNIT_ASSERT_EQUAL(game_dir + "/", GameConfig::GetGameDirectory());
}

void TestGameConfig::testGetAbsolutePath()
{
  STACKTRACE;
  std::string game_dir = "/home/yura/gm";
  GameConfig::SetGameDirectory("gamedata/music");
  
  CPPUNIT_ASSERT_EQUAL(std::string("gamedata/music/license.txt"), GameConfig::GetAbsolutePath("license.txt"));
  CPPUNIT_ASSERT_EQUAL(std::string("INSTALL"), GameConfig::GetAbsolutePath("INSTALL"));
}

CPPUNIT_TEST_SUITE_REGISTRATION( TestGameConfig );
