/*
This file is part of "TW-Light" 
                    http://tw-light.berlios.de/
Copyright (C) 2001-2004  TimeWarp development team

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/


#include "gameconfig.h"
#include "scp.h"
#include "allegro.h"
#include "util/errors.h"

std::string GameConfig::game_data_dir = "";

void GameConfig::SetGameDirectory(const std::string& gamedir)
{
  STACKTRACE;
  if(!gamedir.length())
    return;

  if(gamedir[gamedir.length()-1] == '/' || gamedir[gamedir.length()-1] == '\\')
    {
      game_data_dir = gamedir;
    }
  else
    {
      game_data_dir = gamedir + "/";
    }
}

std::string GameConfig::GetGameDirectory()
{
  STACKTRACE;
  return game_data_dir;
}

std::string GameConfig::GetAbsolutePath(const std::string& file)
{
  STACKTRACE;
  if(!file.length())
    return "";
  if(file[0] == '/')
    {
      return file;
    }
  if(file.length()>2&&file[1]==':')
    {
      return file;
    }
  if(exists( file.c_str()))
    {
      return file;
    }
  else if(exists( (GetGameDirectory() + file).c_str()))
    {
      return GetGameDirectory() + file;
    }
  else if (exists( data_full_path(file).c_str()))
    {
      return data_full_path(file);
    }
  return "";
}

