/*
This file is part of "TW-Light" 
                    http://tw-light.berlios.de/
Copyright (C) 2001-2004  TimeWarp development team

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

#ifndef __TW_LIGHT_GAMEDIALOG_H__
#define __TW_LIGHT_GAMEDIALOG_H__

#include <vector>
#include <string>

/// Provide dialog api 
class DialogApi
{
 public:
  /// Save game state, pause game, init stuff to show dialog
  static void startDialog();
  /// Return to predialog game state
  static void endDialog();
  
  /// player should select from answer variants
  ///
  /// \return player answer position
  static int askPlayer(const std::vector<std::string>& answers);
  
  /// show alien text
  ///
  /// @param text alien text
  /// @param delay how long to display msec
  /// @param x center text position (from 0 to 100)
  /// @param y center text position (from 0 to 100)
  static void showText(const std::string& text, int delay, int x, int y);
  
  /// show that ugly alien face
  ///
  /// @param file path from game directory
  static void showAlienPicture(const std::string& path);
};

#endif

